#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct UpdateContainerizedExtractorRequest {
    #[builder(default, into)]
    #[serde(rename = "name", skip_serializing_if = "Option::is_none", default)]
    name: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "description", skip_serializing_if = "Option::is_none", default)]
    description: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "inputs", skip_serializing_if = "Option::is_none", default)]
    inputs: Option<Vec<super::FileExtractionInput>>,
    #[builder(default, into)]
    #[serde(rename = "parameters", skip_serializing_if = "Option::is_none", default)]
    parameters: Option<Vec<super::FileExtractionParameter>>,
    #[builder(default, into)]
    #[serde(rename = "properties", skip_serializing_if = "Option::is_none", default)]
    properties: Option<std::collections::BTreeMap<String, String>>,
    #[builder(default, into)]
    #[serde(rename = "labels", skip_serializing_if = "Option::is_none", default)]
    labels: Option<std::collections::BTreeSet<String>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::TimestampMetadata>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "timestampMetadata",
        skip_serializing_if = "Option::is_none",
        default
    )]
    timestamp_metadata: Option<Box<super::TimestampMetadata>>,
    #[builder(default, into)]
    #[serde(
        rename = "outputFileFormat",
        skip_serializing_if = "Option::is_none",
        default
    )]
    output_file_format: Option<super::FileOutputFormat>,
    #[builder(default, into)]
    #[serde(rename = "registry", skip_serializing_if = "Option::is_none", default)]
    registry: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "repository", skip_serializing_if = "Option::is_none", default)]
    repository: Option<String>,
    #[builder(default, into)]
    #[serde(rename = "tags", skip_serializing_if = "Option::is_none", default)]
    tags: Option<std::collections::BTreeSet<String>>,
    #[builder(default, into)]
    #[serde(rename = "defaultTag", skip_serializing_if = "Option::is_none", default)]
    default_tag: Option<String>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::Authentication>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "authentication", skip_serializing_if = "Option::is_none", default)]
    authentication: Option<Box<super::Authentication>>,
    #[builder(default, into)]
    #[serde(rename = "command", skip_serializing_if = "Option::is_none", default)]
    command: Option<String>,
}
impl UpdateContainerizedExtractorRequest {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn name(&self) -> Option<&str> {
        self.name.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn description(&self) -> Option<&str> {
        self.description.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn inputs(&self) -> Option<&[super::FileExtractionInput]> {
        self.inputs.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn parameters(&self) -> Option<&[super::FileExtractionParameter]> {
        self.parameters.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn properties(&self) -> Option<&std::collections::BTreeMap<String, String>> {
        self.properties.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn labels(&self) -> Option<&std::collections::BTreeSet<String>> {
        self.labels.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn timestamp_metadata(&self) -> Option<&super::TimestampMetadata> {
        self.timestamp_metadata.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn output_file_format(&self) -> Option<&super::FileOutputFormat> {
        self.output_file_format.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn registry(&self) -> Option<&str> {
        self.registry.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn repository(&self) -> Option<&str> {
        self.repository.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn tags(&self) -> Option<&std::collections::BTreeSet<String>> {
        self.tags.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn default_tag(&self) -> Option<&str> {
        self.default_tag.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn authentication(&self) -> Option<&super::Authentication> {
        self.authentication.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn command(&self) -> Option<&str> {
        self.command.as_ref().map(|o| &**o)
    }
}
